package simulacion;

import java.util.*;
import java.io.*;

/**
 * 
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class MiMundo
{
    private ArrayList<PaginaWeb> mundo;
    private MatrizGoogle google;
    private static final double D = 0.85;
    
    /**
     * Constructor por defecto de un mundo
     */
    public MiMundo() 
    {
        mundo = new ArrayList<PaginaWeb>();
    }  
    
    /**
     * Aade una pgina web al mundo.
     * @param p pgina que se quiere aadir
     */
    public void aadirPagina(PaginaWeb p)
    {
        mundo.add(p);
    }
    
    /**
     * Retorna el total de pginas web que hay en mi mundo.
     * @return total de pginas web
     */
    public int getTotalPaginas() 
    {
        return mundo.size();
    }
    
    /**
     * Retorna la pgina i-sima guardada
     * @param i ndice de la lista
     * @return pgina web guardada en la posicin i-sima
     */
    public PaginaWeb getPaginaI(int i)
    {
        return mundo.get(i);
    }
    
    /**
     * Retorna el PageRank de la pgina i-sima.
     * @param i ndice de la lista
     * @return PageRank de la pgina web guardada en la posicin i-sima
     */
    public double getPageRankI(int i) {
        return getPaginaI(i).getPageRank();
    } 
    
    /**
     * Calcula PageRank de cada pgina y lo guarda en el campo correspondiente de la pgina
     */    
    public void calcularPageRank()
    {
        crearMatrizGoogle();        
        Matriz ranking = google.calcularPageRank();
        
        for (int i = 0; i < ranking.getDimensionFila(); i++) {
            PaginaWeb p = getPaginaI(i);
            p.setPageRank(ranking.getIJ(i,0));
        }
    }                       
    
    /**
     * Guarda los datos de ttulo de pgina y PageRank a un fichero
     * @param nombreFichero nombre fichero a guardar datos
     */
    public void guardarResultadosPageRankEnFichero(String nombreFichero) 
    {
        //HACER
    }
    
    /**
     * Genera la matriz de Google con los datos guardados en mi mundo.
     */
    private void crearMatrizGoogle()
    {
        //HACER
    }
    
    /**
     * Retorna el ndice dentro de la lista donde esta la pgina
     * que tiene como nombre de fichero el argumento.
     * @param pagNomFich nombre de fichero de la pgina
     * @return indice dentro la lista donde se encuentra la pgina con nombre de fichero pagNomFich
     */
    private int numeroPagina(String pagNomFich) 
    {
        boolean encontrado = false;
        int numPag = -1;
        
        for (int i = 0; i < getTotalPaginas() && !encontrado; i++) {
            encontrado = pagNomFich.equals(getPaginaI(i).getNombreFichero());            
            if (encontrado) {
                numPag = i;
            }
        }
        return numPag;
    }
    
    public static void main(String[] args)
    {
        MiMundo pequeo = new MiMundo();
        for (int i = 0; i < 6; i++) {
            PaginaWeb p = new PaginaWeb("t" + i + ".txt");
            pequeo.aadirPagina(p);            
        }
        pequeo.calcularPageRank();
        pequeo.guardarResultadosPageRankEnFichero("resultados.txt");        
    }
            
        
        
        
}
