package simulacion;

import java.util.*;
import java.io.*;

/**
 * Clase para abstraer los datos de una pgina web
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class PaginaWeb
{
    private String titulo;
    private String nombreFichero;
    private ArrayList<String> links;
    private double pageRank;
    
    /**
     * Constructor por defecto.
     */
    public PaginaWeb() 
    {
        links = new ArrayList<String>();
        pageRank = -1;
    }
    
    public PaginaWeb(String nomFich) 
    {
        links = new ArrayList<String>();
        pageRank = -1;
        cargarDatos(nomFich);
    }
    
    /**
     * Retorna el ttulo de la pgina web.
     * @return ttulo de la pgina web
     */
    public String getTitulo() 
    {
        return titulo;
    }
    
    /**
     * Retorna el nombre del fichero de la pgina web.
     * @return nombre de fichero de la pgina web
     */
    public String getNombreFichero()
    {
        return nombreFichero;
    }
    
    /**
     * Retorna el PageRank de la pgina web. Si retorna -1, no est calculado el PageRank.
     * @return PageRank de la pgina web
     */
    public double getPageRank() 
    {
        return pageRank;
    }
    
    /**
     * Retorna el total de links que hay en la pgina web.
     * @return total de links en pgina web
     */
    public int getTotalLinks() 
    {
        return links.size();
    }
    
    /**
     * Retorna el nombre del i-simo link que hay en la pgina web.
     * @return nombre del i-simo link guardado
     */
    public String getLinkI(int i)
    {
        return links.get(i);
    }
    
    /**
     * Modifica el PageRank de la pgina.
     * @param r nuevo PageRank
     */
    public void setPageRank(double r)
    {
        pageRank = r;
    }
        
    
    /**
     * Carga los datos de ttulo, nombre fichero y links de un fichero con el formato correcto.
     * @param nombreFichero nombre del fichero para cargar los datos
     */
    public void cargarDatos(String nomFich)
    {
        //HACER
    }
        
    
    /**
     * Retorna un String con informacin de ttulo y PageRank.
     * @return String con datos de ttulo y PageRank
     */
    public String toString()
    {
        String res = "Ttulo: " +  getTitulo() + ". PageRank: " + getPageRank();
        return res;
    }
        
}
